#ifndef COMBINEDTRANSFORMS_INCLUDED
#define COMBINEDTRANSFORMS_INCLUDED

#include <map>
#include <vector>

#include <IMarchingMethod.h>

class CCombinedTransforms
	: public IMarchingMethod
{
public:
	CCombinedTransforms(void);
	~CCombinedTransforms(void);
	bool GenerateMesh(float isoLevel);
protected:
	void SetupVertexPool(void);
private:
	float GetTriangleArrayQuality(const float *vertexArray, const int *triangleArray, int triangleCount) const;
	bool MeshChoose(void);
	int GenerateVertex(float x, float y, float z, int edgeName);
	inline int GetEdgeId(int x, int y, int z, int edgeName) const;
	inline int GetVertexId(int x, int y, int z) const;
	void RenameElements(void);
protected:
	std::map<int, int> m_vertexToEdgeMap;
	static const int m_edgeTable[256];
	static const int m_triangleTable[256][16];
};

#endif // COMBINEDTRANSFORMS_INCLUDED

