#ifndef MYMATH_INCLUDED
#define MYMATH_INCLUDED

class CMyMath
{
public:
	static CMyMath& Instance(void)
	{
		if (!m_instance)
		{
			// Check for dead reference.
			if (m_isDestroyed)
				OnDeadReference();
			else
				// First callinitialize.
				Create();
		}

		return *m_instance;
	}
	static float FloatEpsilon(void);
	static float FloatMax(void);
	static float FloatMin(void);
	static float FloatRandom(void);
	static bool IsFloatValid(float n);
	static short ShortMax(void);
	static double Pi(void);
private:
	CMyMath(void);
	CMyMath(const CMyMath&);
	CMyMath& operator=(const CMyMath&);
	virtual ~CMyMath(void);
	// Create a new CMyMath and store a pointer to it in m_instance.
	static void Create(void);
	// Gets called if dead reference detected
	static void OnDeadReference(void);
	static void CalculateFloatEpsilon(void);
protected:
	static float m_floatEpsilon;
	static CMyMath* m_instance;
	static bool m_isDestroyed;
};

#endif // MYMATH_INCLUDED

