#include <MyMath.h>
#include <ErrorManager.h>

#include <BoundingBox.h>

using namespace std;

/**
*/
CBoundingBox::CBoundingBox(void)
{
	Create();
}

/**
*/
CBoundingBox::~CBoundingBox(void)
{
}

/**
*/
bool CBoundingBox::SetMesh(boost::shared_ptr<CVertexPool> mesh)
{
	int vertexCount,
		i;
	const float *vertex;

	vertexCount = mesh->GetVertexCount();

	m_xMin = CMyMath::Instance().FloatMax();
	m_xMax = CMyMath::Instance().FloatMin();
	m_yMin = CMyMath::Instance().FloatMax();
	m_yMax = CMyMath::Instance().FloatMin();
	m_zMin = CMyMath::Instance().FloatMax();
	m_zMax = CMyMath::Instance().FloatMin();

	vertex = mesh->GetVertexArray();

	for (i=0; i!=vertexCount; i++)
	{
		if (m_xMin > *vertex)
			m_xMin = *vertex;
		if (m_xMax < *vertex)
			m_xMax = *vertex;

		vertex++;

		if (m_yMin > *vertex)
			m_yMin = *vertex;
		if (m_yMax < *vertex)
			m_yMax = *vertex;

		vertex++;

		if (m_zMin > *vertex)
			m_zMin = *vertex;
		if (m_zMax < *vertex)
			m_zMax = *vertex;

		vertex++;
	}

	return true;
}

/**
*/
void CBoundingBox::Create(void)
{
	m_xMin = 0.0f;
	m_xMax = 0.0f;
	m_yMin = 0.0f;
	m_yMax = 0.0f;
	m_zMin = 0.0f;
	m_zMax = 0.0f;
}

